// @file sns_amd.proto
//
// @brief Defines message types for the Absolute Motion Detector (AMD) Sensors.
//
// @copyright
// Copyright (c) 2023-2024 Qualcomm Innovation Center, Inc. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause-Clear
//
// @details AMD determines motion and stationary states.
// Motion detectors that derive from amd.proto must define their own
// SNS_STD_SENSOR_ATTRID_TYPE
//
// ## Attribute Requirements:
// 1. SNS_STD_SENSOR_ATTRID_TYPE: "amd"
// 2. SNS_STD_SENSOR_ATTRID_STREAM_TYPE: SNS_STD_SENSOR_STREAM_TYPE_ON_CHANGE
// 3. SNS_STD_SENSOR_ATTRID_RIGID_BODY: sns_std_sensor_rigid_body_type
// 4. SNS_STD_SENSOR_ATTRID_API attribute contains "sns_amd.proto"
//
// ## Processing Stream Requests:
// - SNS_STD_SENSOR_MSGID_SNS_STD_ON_CHANGE_CONFIG is used to enable the sensor
//
// ## Publishing Stream Events:
// - SNS_AMD_MSGID_SNS_AMD_EVENT: The sns_amd_event message is used to publish updated state
// - AMD does not publish configuration events.

syntax = "proto2";
import "nanopb.proto";
import "sns_std_sensor.proto";


// @brief Message IDs for AMD Sensor
enum sns_amd_msgid {
  option (nanopb_enumopt).long_names = false;

  SNS_AMD_MSGID_SNS_AMD_EVENT = 772;
}

// @brief States generated by AMD and derived sensors as its output
enum sns_amd_event_type
{
  option (nanopb_enumopt).long_names = false;

  SNS_AMD_EVENT_TYPE_UNKNOWN          = 0;
  SNS_AMD_EVENT_TYPE_STATIONARY       = 1;
  SNS_AMD_EVENT_TYPE_MOTION           = 2;
}

// @brief Event generated by AMD to convey determined state
message sns_amd_event
{
  // @brief AMD motion state
  required sns_amd_event_type state = 1 [default = SNS_AMD_EVENT_TYPE_UNKNOWN];
}
